diff --git a/Zend/tests/gh10935.phpt b/Zend/tests/gh10935.phpt
new file mode 100644
index 0000000000000..6e317546a7cdb
--- /dev/null
+++ b/Zend/tests/gh10935.phpt
@@ -0,0 +1,23 @@
+--TEST--
+GH-1093: Static properties in traits are not overwritten
+--FILE--
+<?php
+trait Foo {
+    static $test;
+}
+
+class A {
+    use Foo;
+}
+
+class B extends A {
+    use Foo;
+}
+
+A::$test = 'A';
+B::$test = 'B';
+var_dump(A::$test, B::$test);
+?>
+--EXPECT--
+string(1) "A"
+string(1) "B"
diff --git a/Zend/zend_inheritance.c b/Zend/zend_inheritance.c
index 028bdebbfb8f7..5a689408263ab 100644
--- a/Zend/zend_inheritance.c
+++ b/Zend/zend_inheritance.c
@@ -2377,7 +2377,9 @@ static void zend_do_traits_property_binding(zend_class_entry *ce, zend_class_ent
 								ZSTR_VAL(prop_name),
 								ZSTR_VAL(ce->name));
 					}
-					continue;
+					if (!(flags & ZEND_ACC_STATIC)) {
+						continue;
+					}
 				}
 			}
 
